﻿----------------------------------------------------------------
--	Developments
----------------------------------------------------------------

----------------------------------------------------------------
--	Library
----------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("GridStatusRaidDebuff")
local BWL = AceLibrary("AceLocale-2.2"):new("BigWigs")
local Aura = AceLibrary("SpecialEvents-Aura-2.0")
local BZ = LibStub("LibBabble-Zone-3.0")
local LBZ = BZ:GetLookupTable()
local reverseLBZ = BZ:GetReverseLookupTable()
local BB = LibStub("LibBabble-Boss-3.0"):GetLookupTable()
local RL = AceLibrary("Roster-2.1")
local zone, zoneName, current_boss
local bossmod_activated = {}
local boss_enable_fmt = string.gsub(BWL["%s mod enabled"],"%%s","")

----------------------------------------------------------------
--	Module
----------------------------------------------------------------
GridStatusRaidDebuff = GridStatus:NewModule("GridStatusRaidDebuff")

local GridStatusRaidDebuff = GridStatusRaidDebuff
GridStatusRaidDebuff.menuName = L["Raid Debuff"]
GridStatusRaidDebuff.options = false

GridStatusRaidDebuff.defaultDB = {
	debug = false,

	alert_RaidDebuff = {
		text = L["Raid Debuff"],
		desc = L["Raid Debuff"],
		enalbe = true,
		color = { r = 1.0, g = 0.0, b = 0.0, a = 1 },
		priority = 99,
		range = false,
		debuff_list = {
			--Serpentshrine Cavern
			Serpentshrine_Cavern = {
				rapantInfection = {name = L["Rampant Infection"], enable = true, owner = L["Trash Mob"], icon = "Spell_Nature_NullifyDisease", cf = {}},
				parasite = {name = L["Serpentshrine Parasite"], enable = true, owner = L["Trash Mob"], icon = "INV_Misc_MonsterHead_03", cf = {}},
				waterTomb = {name = L["Water Tomb"], enable = true, owner = BB["Hydross the Unstable"], icon = "Spell_Frost_ManaRecharge", cf = {}},
				vileSludge = {name = L["Vile Sludge"] , enable = true, owner = BB["Hydross the Unstable"], icon = "Spell_Nature_AbolishMagic", cf = {}},
				wateryGrave = {name = L["Watery Grave"], enable = true, owner = BB["Morogrim Tidewalker"], icon = "Spell_Shadow_DemonBreath", cf = {}},
				insidious = {name = L["Insidious Whisper"], enable = true, owner = BB["Leotheras the Blind"], icon = "Spell_Shadow_ManaFeed", cf = {}},
				chaosBlast = {name = L["Whirlwind"], enable = true, owner = BB["Leotheras the Blind"], icon = "Ability_Gouge", cf = {}},
				staticCharge = {name = L["Static Charge"], enable = true, owner = BB["Lady Vashj"], icon = "Spell_Nature_LightningOverload", cf = {}},
			},
			--The Eye
			Tempest_Keep = {
				sawBlade = {name = L["Saw Blade"], enable = true, owner = L["Trash Mob"], icon = "Ability_Gouge", cf = {}},
				fragmentationBomb = {name = L["Fragmentation Bomb"], enable = true, owner = L["Trash Mob"], icon = "INV_Misc_Bomb_02", cf = {}},
				shellShock = {name = L["Shell Shock"], enable = true, owner = L["Trash Mob"], icon = "Spell_Fire_SelfDestruct", cf = {}},
				wrathOfTheAstromancer = {name = L["Wrath of the Astromancer"], enable = true, owner = BB["High Astromancer Solarian"], icon = "Spell_Arcane_ArcaneTorrent", cf = {}},
				remoteToy = {name = L["Remote Toy"], enable = true, owner = BB["Kael'thas Sunstrider"], icon = "INV_Misc_Urn_01", cf = {[1]="WARRIOR", [2]="DRUID"}},
				mindControl = {name = L["Mind Control"], enable = true, owner = BB["Kael'thas Sunstrider"], icon = "Spell_Shadow_ShadowWordDominate", cf = {}},
			},
			Hyjal_Summit = {
				icebolt = {name = L["Icebolt"], enable = true, owner = BB["Rage Winterchill"], icon = "Spell_Frost_FrostBolt02", cf = {}},
				carrionSwarm = {name = L["Carrion Swarm"], enable = true, owner = BB["Anetheron"], icon = "Spell_Shadow_CarrionSwarm", cf = {[1]="PRIEST", [2]="PALADIN", [3]="SHAMAN", [4]="DRUID"}},
				sleep = {name = L["Sleep"], enable = true, owner = BB["Anetheron"], icon = "Spell_Nature_Sleep", cf = {}},
				doom = {name = L["Doom"], enable = true, owner = BB["Azgalor"], icon = "Ability_Creature_Cursed_02", cf = {}},
				howlOfAzgalor = {name = L["Howl of Azgalor"], enable = true, owner = BB["Azgalor"], icon = "Spell_Shadow_ImpPhaseShift", cf = {[1]="PRIEST", [2]="PALADIN", [3]="SHAMAN", [4]="DRUID"}},
				unquenchableFlames = {name = L["Unquenchable Flames"], enable = true, owner = BB["Azgalor"], icon = "Spell_Shadow_RainOfFire", cf = {}},
				doomfire = {name=L["Doomfire"], enable = true, owner = BB["Archimonde"], icon="Spell_Fire_Incinerate", cf = {}},
				gripOfTheLegion = {name = L["Grip of the Legion"], enable = true, owner = BB["Archimonde"], icon = "INV_Gauntlets_03", cf = {}},
			},
			Black_Temple = {
				impalingSpine = {name = L["Impaling Spine"], enable = true, owner = BB["High Warlord Naj'entus"], icon = "Spell_Frost_IceShard", cf = {}},
				incinerate = {name = L["Incinerate"], enable = true, owner = BB["Teron Gorefiend"], icon = "Spell_Fire_Burnout", cf = {}},
				shadowOfDeath = {name = L["Shadow of Death"], enable = true, owner = BB["Teron Gorefiend"], icon = "Spell_Arcane_PrismaticCloak", cf = {}},
				crushingShadows = {name = L["Crushing Shadows"], enable = true, owner = BB["Teron Gorefiend"], icon = "Spell_Shadow_UnholyFrenzy", cf = {}},
				felRage = {name = L["Fel Rage"], enable = true, owner = BB["Gurtogg Bloodboil"], icon = "Spell_Fire_ElementalDevastation", cf = {}},
				acidicWound = {name = L["Acidic Wound"], enable = true, owner = BB["Gurtogg Bloodboil"], icon = "Ability_Gouge", cf = {}},
				felAcid = {name = L["Fel-Acid Breath"], enable = true, owner = BB["Gurtogg Bloodboil"], icon = "Spell_Nature_Acid_01", cf = {}},
				bloodBoil = {name = L["Bloodboil"], enable = true, owner = BB["Gurtogg Bloodboil"], icon = "Spell_Shadow_BloodBoil", cf = {}},
				soulDrain = {name = L["Soul Drain"], enable = true, owner = BB["Reliquary of Souls"], icon = "Spell_Shadow_Teleport", cf = {}},
				deaden = {name = L["Deaden"], enable = true, owner = BB["Reliquary of Souls"], icon = "Spell_Shadow_SoulLeech_1", cf = {}},
				debilitatingStrike  = { name = L["Debilitating Strike"], enable = true, owner = BB["Shade of Akama"], icon = "Ability_Warrior_WeaponMastery", cf = {}},
				debilitatingPoison  = { name = L["Debilitating Poison"], enable = true, owner = BB["Shade of Akama"], icon = "Ability_PoisonSting", cf = {}},
				vileBeam = {name = L["Vile Beam"], enable = true, owner = BB["Mother Shahraz"], icon = "Spell_Shadow_ShadowBolt", cf = {}},
				fatalAttraction = {name = L["Fatal Attraction"], enable = true, owner = BB["Mother Shahraz"], icon = "Spell_Shadow_ShadowMend", cf = {}},
				deadlyPoison = {name = L["Deadly Poison"], enable = true, owner = BB["The Illidari Council"], icon = "Ability_Rogue_DualWeild", cf = {}},
				flamestrike = {name = L["Flamestrike"], enable = true, owner = BB["The Illidari Council"], icon = "Spell_Fire_SelfDestruct", cf = {}},
				divineWrath = {name = L["Divine Wrath"], enable = true, owner = BB["The Illidari Council"], icon = "Spell_Holy_SearingLight", cf = {}},
				parasiticShadowfiend = {name = L["Parasitic Shadowfiend"], enable = true, owner = BB["Illidan Stormrage"], icon = "Spell_Shadow_SoulLeech_3", cf = {}},
				darkBarrage =  {name = L["Dark Barrage"], enable = true, owner = BB["Illidan Stormrage"], icon = "Spell_Shadow_PainSpike", cf = {}},
				shear =  {name = L["Shear"], enable = true, owner = BB["Illidan Stormrage"], icon = "Spell_Shadow_FocusedPower", cf = {}},
				agonizingFlames =  {name = L["Agonizing Flames"], enable = true, owner = BB["Illidan Stormrage"], icon = "Spell_Fire_BlueImmolation", cf = {}},
			},
			Zul__Aman = {
				mangle = {name = L["Mangle"], enable = true, owner = BB["Nalorakk"], icon = "Ability_Druid_Mangle2", cf = {}},
				electricalStorm = {name = L["Electrical Storm"], enable = true, owner = BB["Akil'zon"], icon = "Spell_Lightning_LightningBolt01", cf = {}},
				staticDisruption = {name = L["Static Disruption"], enable = true, owner = BB["Akil'zon"], icon = "Spell_Nature_LightningOverload", cf = {}},
				flameBuffet = {name = L["Flame Buffet"], enable = true, owner = BB["Jan'alai"], icon = "Spell_Fire_Fireball", cf = {}},
				flameShock = {name = L["Flame Shock"], enable = true, owner = BB["Halazzi"], icon = "Spell_Fire_FlameShock", cf = {}},
				coldStare = {name = L["Cold Stare"], enable = true, owner = BB["Hex Lord Malacrass"], icon = "Spell_Shadow_SpectralSight", cf = {}},
				grievousThrow = {name = L["Grievous Throw"], enable = true, owner = BB["Zul'jin"], icon = "Ability_BackStab", cf = {}},
				creepingParalysis = {name = L["Creeping Paralysis"], enable = true, owner = BB["Zul'jin"], icon = "Spell_Nature_TimeStop", cf = {}},
				clawRage = {name = L["Claw Rage"], enable = true, owner = BB["Zul'jin"], icon = "Ability_Druid_Mangle", cf = {}},
			},
			Karazhan = {
				holyFire =  {name = L["Holy Fire"], enable = true, owner = BB["Maiden of Virtue"], icon = "Spell_Holy_SearingLight", cf = {}},
				repentance =  {name = L["Repentance"], enable = true, owner = BB["Maiden of Virtue"], icon = "Spell_Holy_PrayerOfHealing", cf = {}},
				garrote = {name = L["Garrote"], enable = true, owner = BB["Moroes"], icon = "Ability_Rogue_Garrote", cf = {}},
				blind = {name = L["Blind"], enable = true, owner = BB["Moroes"], icon = "Spell_Shadow_MindSteal", cf = {}},
				gouge = {name = L["Gouge"], enable = true, owner = BB["Moroes"], icon = "Ability_Gouge", cf = {}},
				redRidingHood  = {name = L["Red Riding Hood"], enable = true, owner = BB["The Big Bad Wolf"], icon = "INV_Helmet_28", cf = {}},
				sacrifice = {name = L["Sacrifice"], enable = true, owner = BB["Terestian Illhoof"], icon = "Spell_Shadow_AntiMagicShell", cf = {}},
				enfeeble = {name = L["Enfeeble"], enable = true, owner = BB["Prince Malchezaar"], icon = "Spell_Shadow_LifeDrain02", cf = {}},
			}
		}
	}
}

function GridStatusRaidDebuff:ChangeSpace(word)
	local word = word
	word = string.gsub(word,"'","__")
	return string.gsub(word," ","_")
end

function GridStatusRaidDebuff:RepairSpace(word)
	local word = word
	word = string.gsub(word,"__","'")
	return string.gsub(word,"_"," ")
end

function GridStatusRaidDebuff:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatuses()
end

function GridStatusRaidDebuff:OnEnable()
	self.debugging = self.db.profile.debug

	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_LEAVING_WORLD")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneCheck")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "UpdateAllUnits")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "UpdateAllUnits")
	self:RegisterEvent("PLAYER_ALIVE", "UpdateAllUnits")
	self:RegisterEvent("PLAYER_DEAD", "UpdateAllUnits")
	self:RegisterEvent("PLAYER_UNGHOST", "UpdateAllUnits")
	self:RegisterEvent("Grid_UnitJoined")
	self:RegisterEvent("SpecialEvents_UnitDebuffGained", "UpdateUnit")
	self:RegisterEvent("SpecialEvents_UnitDebuffLost", "UpdateUnit")
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	self:RegisterEvent("BigWigs_Message")
end

function GridStatusRaidDebuff:ZoneCheck()
	zone = GetRealZoneText()
	if string.len(zone) > 1 then
		zoneName = self:ChangeSpace(reverseLBZ[zone])
	end
end

function GridStatusRaidDebuff:BigWigs_Message(msg)
	bossname = string.gsub(msg,boss_enable_fmt,"")
	if not(bossname == msg) then
		table.insert(bossmod_activated,bossname)
	end
end

function GridStatusRaidDebuff:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
	for bid,bossname in pairs(bossmod_activated,bossname) do
		if msg ==  UNITDIESOTHER:format(bossname) then
			table.remove(bossmod_activated ,bid)
			return
		end
	end
end

function GridStatusRaidDebuff:PLAYER_ENTERING_WORLD()
	if zone == nil then
		self:ZoneCheck()
	end
	self:UpdateAllUnits()
	self:RegisterEvent("SpecialEvents_UnitDebuffGained", "UpdateUnit")
	self:RegisterEvent("SpecialEvents_UnitDebuffLost", "UpdateUnit")
end

function GridStatusRaidDebuff:PLAYER_LEAVING_WORLD()
	self:UnregisterEvent("SpecialEvents_UnitDebuffGained")
	self:UnregisterEvent("SpecialEvents_UnitDebuffLost")
end

function GridStatusRaidDebuff:Grid_UnitJoined(name, unitid)
	self:Debug("Joined",name)
	self:UpdateUnit(unitid)
end

function GridStatusRaidDebuff:RegisterStatuses()
	self:RegisterStatus("alert_RaidDebuff",L["Raid Debuff"],GridStatusRaidDebuff:CreateDebuffZoneList(),true)
end

function GridStatusRaidDebuff:UnregisterStatuses()
	self:UnregisterStatus("alert_RaidDebuff",L["Raid Debuff"])
end

function GridStatusRaidDebuff:CreateDebuffZoneList()
	local debuff_list = self.db.profile["alert_RaidDebuff"].debuff_list
	local debuff_menu = {}

	for debuffZone, debuffZoneInfo in pairs(debuff_list) do
		local list = {}
		for debuffName, debuffInfo in pairs(debuffZoneInfo) do
			list[debuffName] = GridStatusRaidDebuff:CreateDebuffList(debuffName, debuffZone, debuffInfo)
		end

		debuff_menu[debuffZone] = {
			type = "group",
			name = LBZ[self:RepairSpace(debuffZone)],
			desc = L["Raid Debuff"].." : "..LBZ[self:RepairSpace(debuffZone)],
			args = list
		}
	end
	return debuff_menu
end

function GridStatusRaidDebuff:CreateDebuffList(debuff, zone, debuffInfo)
	return {
		type = "toggle",
		name = debuffInfo.owner.." : "..debuffInfo.name,
		desc = LBZ[self:RepairSpace(zone)].." : "..debuffInfo.owner,
		get = function() return debuffInfo.enable end,
		set = function(v) debuffInfo.enable = not debuffInfo.enable end,
	}
end

function GridStatusRaidDebuff:Reset()
	self.super.Reset(self)
	self:UnregisterStatuses()
	self:RegisterStatuses()
end

function GridStatusRaidDebuff:UpdateAllUnits()
	self:Debug("updating all units")
	for u in RL:IterateRoster() do
		self:UpdateUnit(u.unitid)
	end
end

function GridStatusRaidDebuff:UpdateUnit(unitid)
	self:Debug("Updating Unit",UnitName(unitid))
	self:ShowBossDebuffs(unitid)
end

function GridStatusRaidDebuff:ListHasBoss(owner)
	if owner == L["Trash Mob"] then
		return true
	end

	for bid,bossname in pairs(bossmod_activated) do
		if owner == bossname then
			return true
		end
	end
	return false
end

function GridStatusRaidDebuff:CFHasClass(CF, class)
	if table.maxn(CF) == 0 then
		return true
	end
	for cid, filter in pairs(CF) do
		if filter == class then return true end
	end
	return false
end

function GridStatusRaidDebuff:ShowBossDebuffs(unit)
	local name = UnitName(unit)
	local _,class = UnitClass(unit)
	local settings = self.db.profile["alert_RaidDebuff"]
	local debuff_list = settings.debuff_list[zoneName]
	local tmp = nil
	local tex = nil
	if not settings.enable or not debuff_list then
		return self.core:SendStatusLost(name, "alert_RaidDebuff")
	end

	for debuffID, debuff in pairs(debuff_list) do
		if debuff.enable and self:ListHasBoss(debuff.owner) and self:CFHasClass(debuff.cf, class) then
			if Aura:UnitHasDebuff(unit, debuff.name) then
				tmp = debuff
				break
			end
		end
	end

	if tmp then
		self:Debug("gained",status)
		tex = "Interface\\Icons\\"..tmp.icon
		self.core:SendStatusGained(
			name,
			"alert_RaidDebuff",
			settings.priority,
			(tmp.range and 40),
			settings.color,
			tmp.text,
			nil,
			nil,
			tex)
	else
		return self.core:SendStatusLost(name, "alert_RaidDebuff")
	end
end